<?php

class feedback extends Module
{
	private $_html = '';
    private $_postErrors = array();
	
	function __construct()
	{
		$this->name = 'feedback';
		$this->tab = 'Ciroco05';
		$this->version = 1.0;
		
		parent::__construct(); /* The parent construct is required for translations */

		if (Configuration::get('cmsfeedback')) {
			Configuration::updateValue($this->name.'_filepath', Configuration::get('cmsfeedback'), true);
			Configuration::deleteByName('cmsfeedback');
		}
		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('Feedback Module');
		$this->description = $this->l('Get Feedback from your Customers');
		
	}

	    function install()
    {
        if (!parent::install()){
			return false;
        }
        
        if (!$this->updatefile()){
            return false;
        }
		
		if (!$this->_installDB()){
            return false;
        }
		if (!$this->registerHook('rightColumn')){
            return false;
        }
		if (!$this->registerHook('top')){
            return false;
        }
        return true;
    }
	
	
	
	  
	  function uninstall()
    {
        if (!parent::uninstall()){
            return false;
        }
        if (!$this->restorefile()){
            return false;
        }
		 if (!$this->_uninstallDB()){
            return false;
		}
		return true;
    }
	
	 /*
     * @change tpl & php 
     */
    private function updatefile()
    {
        if(!copy(_PS_MODULE_DIR_.$this->name.'/file/signfeedback.php',_PS_ROOT_DIR_.'/signfeedback.php')){
        return false;
            }
		if(!copy(_PS_MODULE_DIR_.$this->name.'/file/viewfeedback.php',_PS_ROOT_DIR_.'/viewfeedback.php')){
        return false;
            }
        return true;
    }

    /**
     *
     * @restore tpl & php <type
     */
    private function restorefile()
    {
        if(file_exists(_PS_ROOT_DIR_.'/signfeedback.php')){
        unlink(_PS_ROOT_DIR_.'/signfeedback.php');
            }	
		if(file_exists(_PS_ROOT_DIR_.'/viewfeedback.php')){
        unlink(_PS_ROOT_DIR_.'/viewfeedback.php');
            }	
						
        return true;
    }
	private function _installDB()
	{
		$query = 'CREATE TABLE IF NOT EXISTS '._DB_PREFIX_.'feedback (
		`id_fb` int(10) NOT NULL AUTO_INCREMENT, 
		`date` date NOT NULL, 
		`name` text,
		`email` text,
		`feedback` text, 
		`permission` TINYINT(1),
		`answer` text ,
		`status` int(10), 
		PRIMARY KEY(`id_fb`)) ENGINE=MyISAM default CHARSET=utf8';
		if (!Db::getInstance()->Execute($query))
			return false;
		return true;
	}

	private function _uninstallDB()
	{
		$query = 'DROP TABLE '._DB_PREFIX_.'feedback';
		if (Db::getInstance()->Execute($query))
			return true;
		return false;
	}

	// validation & postprocess
	
	  private function _postValidation()
    {
       if (isset($_POST['Delete']))
        {
            if (empty($_POST['delete']))
            $this->_postErrors[] = $this->l('No message was selected.');
        }
    }
	
	private function _postProcess()
	{	
		if (isset($_POST[$this->name.'_submit']))
        {
		Configuration::updateValue($this->name.'_filepath', Tools::getValue('cmsfeedback'), true);
		Configuration::updateValue('FDBFORMATDATA', intval(Tools::getValue('fdbfdata')));
		$this->_html .= '<div class="conf confirm">'.$this->l('Settings updated').'</div>';
		}
		
		if (isset($_POST['Save']))
        {
        foreach($_POST['answer'] as $chiave => $valore)
            {
				$approved=Db::getInstance()->Execute('
                UPDATE `'._DB_PREFIX_.'feedback`
                SET `answer` = "'.($valore).'"
                WHERE `id_fb` = "'.($chiave).'"');
			}	
        foreach($_POST['feedback'] as $chiave => $valore)
            {
				$approved=Db::getInstance()->Execute('
                UPDATE `'._DB_PREFIX_.'feedback`
                SET `feedback` = "'.($valore).'"
                WHERE `id_fb` = "'.($chiave).'"');
			}	
		
				
				$approved=Db::getInstance()->Execute('
                UPDATE `'._DB_PREFIX_.'feedback`
                SET `status` = null');
		 
		 if (isset($_POST['display']))
			{
				foreach($_POST['display'] as $chiave => $valore)
				{
					$approved=Db::getInstance()->Execute('
					UPDATE `'._DB_PREFIX_.'feedback`
					SET `status` = 1
					WHERE `id_fb` = "'.($chiave).'"');
				}	
			}
		
		$this->_html .= '<div class="conf confirm">'.$this->l('Feedback updated').'</div>';
		}
		
		if (isset($_POST['Delete']))
        {
		foreach($_POST['delete'] as $chiave => $valore)
            {	
                $deleted=Db::getInstance()->Execute('
                DELETE FROM `'._DB_PREFIX_.'feedback`
                WHERE `id_fb` = "'.($valore).'"');
				$this->_html .= '<div class="conf confirm">'.$this->l('The Feedback has been deleted successfully').' id '.($valore).'</div>';
		
            }
		}
	}
	public function getContent()
	{	
		
			
		$this->_html .= '<h2>'.$this->displayName.'</h2>';
		
		if (Tools::isSubmit($this->name.'_submit')||(Tools::isSubmit('Save')) ||(Tools::isSubmit('Delete')))
		{				
			$this->_postValidation();
            if (!sizeof($this->_postErrors))
            $this->_postProcess();
            else
            foreach ($this->_postErrors AS $err)
            $this->_html .= '<div class="alert error">'. $err .'</div>';
		}
			
		$this->_displayForm();
		$this->_html .= '<br />';
		$this->getFeedbacktodisplay();
		$this->_html .= '<br />';
		$this->getFeedbacknodisplay();
		return $this->_html;
	}

	private function _displayForm()
	{
		

		$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend><img src="../img/admin/cog.gif" alt="" class="middle" />'.$this->l('Settings').'</legend>
				<label style="width: 230px; text-align:left;">'.$this->l('CMS Number of Privacy page').'</label> 
				<div class="margin-form">
					<input type="text" name="cmsfeedback" style="width: 20px;" value="'.Tools::getValue('1', Configuration::get($this->name.'_filepath')).'" />
					'.$this->l('default value:').' 2
				</div>
				<div>
				<label style="width: 230px; text-align:left;">'.$this->l('Data Format').'</label>
				<input type="radio" name="fdbfdata" value="1"'.(Configuration::get('FDBFORMATDATA') ? ' checked="checked"' : '').' />&nbsp;'.$this->l('yyyy/mm/dd').' &nbsp;&nbsp;
				<input type="radio" name="fdbfdata" value="0"'.(!Configuration::get('FDBFORMATDATA') ? ' checked="checked"' : '').' />&nbsp;'.$this->l('dd/mm/yyyy').' &nbsp;&nbsp;
				</div><br />
				<center><input type="submit" name="'.$this->name.'_submit" value="'.$this->l('Update').'" class="button" /></center>			
			</fieldset>
		</form>';

		$this->_html .= '
		<fieldset class="space">
				<h3><i>'.$this->l('Like this module? Want more? Then why not consider donating to the author?').'</i></h3>
				<form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
				<input type="hidden" name="cmd" value="_donations">
				<input type="hidden" name="business" value="P34NF3QLXAC9G">
				<input type="hidden" name="lc" value="IT">
				<input type="hidden" name="item_name" value="donazione Ciroco05">
				<input type="hidden" name="currency_code" value="EUR">
				<input type="hidden" name="bn" value="PP-DonationsBF:btn_donateCC_LG.gif:NonHosted">
				<input type="image" src="https://www.paypal.com/it_IT/IT/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal">
				<img alt="" border="0" src="https://www.paypal.com/it_IT/i/scr/pixel.gif" width="1" height="1">
				</form>

		</fieldset>';				
	}
	
	  function getFeedbacktodisplay()
     {
         $feedback = Db::getInstance()->Execute('
         SELECT * FROM `'._DB_PREFIX_.'feedback`
		 WHERE permission = 1
         ORDER BY id_fb DESC
         ');

         $nb_feedback = mysql_num_rows($feedback);
		
         $this->_html .='
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post" name="form1" >
			        
		<fieldset>
                   <legend><img src="../img/admin/slip.gif" />'.$this->l('Feedback with permission to display').'</legend>';
         if ($nb_feedback == '0')
         {
             $this->_html .= '<div align="left" style="font-size:15px;color: Blue;">'.$this->l('There are not Feedback with permission to display.').'</div>';
         }
         else
         {
            $this->_html .= '
            <table border="0" cellpadding="0" cellspacing="3" id="form">
            <tr>
            <td colspan="4">-----------------------------------------------------------------------------------------------------------------------------</td>
            </tr>
            ';


             while ($aux = mysql_fetch_row($feedback))
           
			{
                $this->_html .='
			
				
			<tr>
			<td align="left"><b>'.'['.' '.$aux[0].''.']'.'</b>
			<font color="blue">'.date('j/m/Y', strtotime($aux[1])).' </font>
			'.$aux[2].' </td>
			<td align="left"><a href="mailto:'.$aux[3].'"><font color="green">'.$aux[3].'</font></a>
			</td>
			<td></td>
			<td></td>
			</tr>
			
			<tr>
			<td align="left">'.$this->l('Feedback').'</td>
			<td align="left">'.$this->l('Answer').'</td>
            <td align="center" style="color: blue;"><b>'.$this->l('Display').'</b></td>
            <td align="center" style="color: red;"><b>'.$this->l('Delete').'</b></td>
           
			
			</tr>
			<td align="left"><textarea style="width: 400px; height: 90px; class="rte"   name="feedback['.$aux[0].']">'.$aux[4].'</textarea></td>
			<td align="left"><textarea style="width: 320px; height: 90px; class="rte"   name="answer['.$aux[0].']">'.$aux[6].'</textarea></td>
			<td align="center" style="vertical-align: top;"><input type=checkbox  name="display['.$aux[0].']" value="'.$aux[0].'"."'.($aux[7] ? ' checked="checked"' : '').'"/></td>
 			<td align="center" style="vertical-align: top;"><input type=checkbox   name="delete[]" value="'.$aux[0].'"/></td>
			</tr>
           	<tr><td colspan="4">-----------------------------------------------------------------------------------------------------------------------------</td></tr>';
            }
            $this->_html .='
			<tr>
			<td  style="vertical-align: bottom;" height="40" colspan="4" align="right">
			<input class="button" name="Save" value="'.$this->l('Save').'" type="submit" style="width: 90px;"/>
			<input class="button" name="Delete" value="'.$this->l('Delete').'" type="submit"  style="width: 90px;" onClick="return confirm(\''.$this->l('Are you sure?', __CLASS__, true, false).'\');" /> 
			</td></tr>
			</table>';}
            $this->_html .='</fieldset></form>
            ';

         return  $this->_html;
     }
	
	  function getFeedbacknodisplay()
     {
         $feedback = Db::getInstance()->Execute('
         SELECT * FROM `'._DB_PREFIX_.'feedback`
		 WHERE permission = 2
         ORDER BY id_fb DESC
         ');

         $nb_feedback = mysql_num_rows($feedback);
		
         $this->_html .='
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post" name="form1" >
			        
		<fieldset>
                   <legend><img src="../img/admin/slip.gif" />'.$this->l('Feedback without permission to display').'</legend>';
         if ($nb_feedback == '0')
         {
             $this->_html .= '<div align="left" style="font-size:15px;color: Blue;">'.$this->l('There are not Feedback without permission to display.').'</div>';
         }
         else
         {
            $this->_html .= '
            <table border="0" cellpadding="0" cellspacing="3" id="form">
            <tr>
            <td colspan="4">-----------------------------------------------------------------------------------------------------------------------------</td>
            </tr>
            ';

             while ($aux = mysql_fetch_row($feedback))
           
			{
                $this->_html .='
			<tr>
			<td align="left"><b>'.'['.' '.$aux[0].''.']'.'</b>
			<font color="blue">'.date('j/m/Y', strtotime($aux[1])).' </font>
			'.$aux[2].' </td>
			<td align="left" ><a href="mailto:'.$aux[3].'"><font color="green">'.$aux[3].'</font></a>
			</td>
			<td></td>
			<td></td>
			</tr>
			
			<tr>
			<td align="left">'.$this->l('Feedback').'</td>
			<td align="left" style="color: silver;">'.$this->l('Answer').'</td>
            <td align="center" style="color: silver;"><b>'.$this->l('Display').'</b></td>
            <td align="center" style="color: red;"><b>'.$this->l('Delete').'</b></td>
           			
			</tr>
			<td align="left"><textarea readonly="readonly" style="width: 400px; height: 90px; class="rte" name="feedback['.$aux[0].']">'.$aux[4].'</textarea></td>
			<td align="left"><textarea disabled="disabled" style="width: 320px; height: 90px; class="rte" name="answer['.$aux[0].']">'.$aux[6].'</textarea></td>
			<td align="center" style="vertical-align: top;">
            <input disabled="disabled" type=checkbox  name="display['.$aux[0].']" value="'.$aux[0].'"."'.($aux[7] ? ' checked="checked"' : '').'"/></td>
 			<td align="center" style="vertical-align: top;">
			<input type=checkbox   name="delete[]" value="'.$aux[0].'"/></td>
			</tr>
           	<tr><td colspan="4">-----------------------------------------------------------------------------------------------------------------------------</td></tr>';
            }
            $this->_html .='
			<tr>
			<td  style="vertical-align: bottom;" height="40" colspan="4" align="right">
			<input class="button" name="Delete" value="'.$this->l('Delete').'" type="submit"  style="width: 90px;" onClick="return confirm(\''.$this->l('Are you sure?', __CLASS__, true, false).'\');" /> 
			</td></tr>
			</table>';}
            $this->_html .='</fieldset></form>
            ';

         return  $this->_html;
     }

	public function hookRightColumn($params)
	{
		return $this->display(__FILE__, 'feedback.tpl');
	}
	public function hooktop($params)
	{
		global $smarty;
		$cmsprivacyid=Configuration::get($this->name.'_filepath');
		if ($cmsprivacyid=='') { 
		  $cmsprivacyid="2";
		}
		$fdb_format_data=Configuration::get('FDBFORMATDATA');
		 $smarty->assign(array(
                'cmsprivacyid'      => $cmsprivacyid,
                'fdb_format_data'  	=> $fdb_format_data
                 ));
		
	}
}

